//C832DX.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "C832DX.h"
#include "DxClass.h"
#include <math.h>
#include <conio.h>
#include <sys/timeb.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//Classe CC832DX ___________________________
CC832DX::CC832DX(long Cte)              
{
	if (GetVersion() & 0x80000000)
	{
		//W98, pas de connexion  Driver X
		m_OKConnect=TRUE;
	}
	else
	{
		//Connexion DriverX
		m_pC832=new CDevice();
		if (!m_pC832->ConnectDevice("c832"))
		{
			AfxMessageBox("Erreur de connexion  DriverX !\n\nParamtres de connexion:\nDevice: c832\nBus Type: ISA\nUses port range\nPort Base: 0X210\nPort Count: 0X4\nIgnore ressource conflicts");
			m_OKConnect=FALSE;
			m_OKCarte=FALSE;
		}
		else
		{
			CDeviceConfig config;
			m_pC832->GetDeviceConfig("c832",&config);
			config.bIgnoreConflicts=TRUE;
			m_pC832->ConfigureDevice("c832",config);
			m_OKConnect=TRUE;
			//Test prsence voie 1 sur carte n1
			m_OKCarte=OK(1);
		}
	}
	//Pour une platine de translation: 1mm -> 120000 incrments
	//Pour une platine de rotation: 1-> 29600 incrments
	m_lCte=Cte;
	//Vitesses maximales:
	//Pour une platine de translation: 100 mm/mn
	//Pour une platine de rotation: 360/mn 
	m_fVit=360.0;	//Vitesse par dfaut
}
//________________________________________
BOOL CC832DX::Connect(void)
{
	if (m_pC832->hDevice==INVALID_HANDLE_VALUE)
		return FALSE;
	else
		return TRUE;
}
//________________________________________
CC832DX::~CC832DX()
{
	if (GetVersion() & 0x80000000)
	{
		//W98, pas de dconnexion  Driver X
	}
	else
	{
		m_pC832->DisconnectDevice();
		delete m_pC832;
	}
}
//________________________________________
void CC832DX::out_port(long a,unsigned char c)
{
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		//Registre de donnes: Offset+0: criture de l'octet
		_outp(a,c);
	}
	else
	{
		//DriverX pour XP
		m_pC832->outp(a-0x210,c);
	}
}
//________________________________________
unsigned char CC832DX::in_port(long a)
{
	unsigned char k;
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		k=_inp(a);
	}
	else
	{
		//DriverX pour XP : enlever l'adresse de base
		k=m_pC832->inp(a-0x210);
	}
	return k;
}
//________________________________________
void CC832DX::SET_DATA_ADR0(BYTE channel)
{   
	out_port(IOADDRREG0,CONF_PARM | channel+1);
}
//________________________________________
void CC832DX::SET_DATA_ADR1(BYTE channel)
{
	out_port(IOADDRREG1,CONF_PARM | channel+1);
}
//________________________________________
// CC832 message handlers
long CC832DX::drive628_0(BYTE channel, BYTE cmd, WORD ctrl_WORD, long parm)
{

	union 
	{
		long long_data;         //converts long<->integer
		short  int_data[2];
	}
	value;

	struct 
	{
		BYTE   cmd;         //command
		short    report;    //Ctrl(0)/Report(1) command
		short    data;      //max. dataWORDs
		short    length32;	//16(0)/32(1) bit valus
	}
	cmd_set[]={
		{RESET, 0,0,0},     //LM628/629-commands exept RDSTAT
		{PORT8, 0,0,0},
		{PORT12,0,0,0},
		{DFH,   0,0,0},
		{SIP,   0,0,0},
		{LPEI,  0,1,0},
		{LPES,  0,1,0},
		{SBPA,  0,2,1},
		{SBPR,  0,2,1},
		{MSKI,  0,1,0},
		{RSTI,  0,1,0},
		{LFIL,  0,4,0},
		{UDF,   0,0,0},
		{LTRJ,  0,3,1},
		{STT,   0,0,0},
		{RDSTAT,1,1,0},
		{RDSIGS,1,1,1},
		{RDIP,  1,1,1},
		{RDDP,  1,1,1},
		{RDRP,  1,1,1},
		{RDDV,  1,1,1},
		{RDRV,  1,1,0},
		{RDSUM, 1,1,0}
	 },
	 *dscr_ptr;           //pointer to command description

	dscr_ptr=cmd_set;     //seeking command description
	if (cmd==RDSTAT)
	{
		(IOADDRREG0,CONF_PARM | channel);
    out_port(IOADDRREG0,CONF_PARM | channel);
		return((long)in_port(IODATAREG0));           //status
	}
	else
	{
		while (cmd!=dscr_ptr->cmd)
		{
		 dscr_ptr++;
		}
	}

	channel <<= 1;
	TEST_BUSY0(channel);
	out_port(IODATAREG0,cmd);                      //command

	if (dscr_ptr->data)
	{                         //read/write data
		if ((cmd==LTRJ) | (cmd==LFIL))
		{
			TEST_BUSY0(channel);
			//SET_DATA_ADR0;
			SET_DATA_ADR0(channel);
			put_WORD0(ctrl_WORD);
		}
		if (dscr_ptr->report)
		{                     //report command
			if (dscr_ptr->length32)
			{                 //32 Bit data
				TEST_BUSY0(channel);
				//SET_DATA_ADR0;
				SET_DATA_ADR0(channel);
				value.int_data[1]=get_WORD0();
				TEST_BUSY0(channel);
				//SET_DATA_ADR0;
				SET_DATA_ADR0(channel);
				value.int_data[0]=get_WORD0();
				return(value.long_data);
			}
			else
			{                                    //16 Bit data
				TEST_BUSY0(channel);
				//SET_DATA_ADR0;
				SET_DATA_ADR0(channel);
				return((long)get_WORD0());
			}
		}
		else
		{                                      //control command
			if (dscr_ptr->length32)
			{               //32 Bit parameter
				value.long_data=parm;
				TEST_BUSY0(channel);
				//SET_DATA_ADR0;
				SET_DATA_ADR0(channel);
				put_WORD0(value.int_data[1]);
				TEST_BUSY0(channel);
				//SET_DATA_ADR0;
				SET_DATA_ADR0(channel);
				put_WORD0(value.int_data[0]);
			}
			else
			{                                    //16 Bit parameter
				TEST_BUSY0(channel);
				//SET_DATA_ADR0;
				SET_DATA_ADR0(channel);
				put_WORD0((short)parm);
			}
		}
	}
	return 0;
}
//________________________________________
long CC832DX::drive628_1(BYTE channel, BYTE cmd, WORD ctrl_WORD, long parm)
{
	union
	{
		long long_data;         //converts long<->integer
		short  int_data[2];
	}
	value;

	struct
	{
		BYTE   cmd;            //command
		short    report;         //Ctrl(0)/Report(1) command
		short    data;           //max. dataWORDs
		short    length32;       //16(0)/32(1) bit valus
	}
	cmd_set[]=
	{
		{RESET, 0,0,0},      //LM628/629-commands exept RDSTAT
		{PORT8, 0,0,0},
		{PORT12,0,0,0},
		{DFH,   0,0,0},
		{SIP,   0,0,0},
		{LPEI,  0,1,0},
		{LPES,  0,1,0},
		{SBPA,  0,2,1},
		{SBPR,  0,2,1},
		{MSKI,  0,1,0},
		{RSTI,  0,1,0},
		{LFIL,  0,4,0},
		{UDF,   0,0,0},
		{LTRJ,  0,3,1},
		{STT,   0,0,0},
		{RDSTAT,1,1,0},
		{RDSIGS,1,1,1},
		{RDIP,  1,1,1},
		{RDDP,  1,1,1},
		{RDRP,  1,1,1},
		{RDDV,  1,1,1},
		{RDRV,  1,1,0},
		{RDSUM, 1,1,0}
	},
	*dscr_ptr;           //pointer to command description

	dscr_ptr=cmd_set;             //seeking command description
	if (cmd==RDSTAT)
	{
		out_port(IOADDRREG1,CONF_PARM | channel);
		return((long)in_port(IODATAREG1));           //status
	}
	else while (cmd!=dscr_ptr->cmd) dscr_ptr++;

	channel <<= 1;
	TEST_BUSY1(channel);
	out_port(IODATAREG1,cmd);                      //command

	if (dscr_ptr->data)
	{                         //read/write data
		if ((cmd==LTRJ) | (cmd==LFIL))
		{
			TEST_BUSY1(channel);
			//SET_DATA_ADR1;
			SET_DATA_ADR1(channel);
			put_WORD1(ctrl_WORD);
		}
		if (dscr_ptr->report)
		{                     //report command
			if (dscr_ptr->length32)
			{                 //32 Bit data
				TEST_BUSY1(channel);
				//SET_DATA_ADR1;
				SET_DATA_ADR1(channel);
				value.int_data[1]=get_WORD1();
				TEST_BUSY1(channel);
				//SET_DATA_ADR1;
				SET_DATA_ADR1(channel);
				value.int_data[0]=get_WORD1();
				return(value.long_data);
			}
			else
			{                                    //16 Bit data
				TEST_BUSY1(channel);
				//SET_DATA_ADR1;
				SET_DATA_ADR1(channel);
				return((long)get_WORD1());
			}
		}
		else
		{                                      //control command
			if (dscr_ptr->length32)
			{               //32 Bit parameter
				value.long_data=parm;
				TEST_BUSY1(channel);
				//SET_DATA_ADR1;
				SET_DATA_ADR1(channel);
				put_WORD1(value.int_data[1]);
				TEST_BUSY1(channel);
				//SET_DATA_ADR1;
				SET_DATA_ADR1(channel);
				put_WORD1(value.int_data[0]);
			}
			else
			{                                    //16 Bit parameter
				TEST_BUSY1(channel);
				//SET_DATA_ADR1;
				SET_DATA_ADR1(channel);
				put_WORD1((short)parm);
			}
		}
	}
	return 0;
}
//________________________________________
//get_WORD:      16 Bit input to IODATAREG
short CC832DX::get_WORD0()
{
	union
	{
		short  int_data;
		BYTE byte_data[2];
	}
	temp;

	temp.byte_data[1]=in_port(IODATAREG0);
	temp.byte_data[0]=in_port(IODATAREG0);
	return temp.int_data;
}
//________________________________________
short CC832DX::get_WORD1()
{
	union
	{
		short  int_data;
		BYTE byte_data[2];
	}
	temp;

	temp.byte_data[1]=in_port(IODATAREG1);
	temp.byte_data[0]=in_port(IODATAREG1);
	return temp.int_data;
}
//________________________________________
//put_WORD:      16 Bit output to IODATAREG
void CC832DX::put_WORD0(short data)
{
	union
	{
		short  int_data;
		BYTE byte_data[2];
	}
	temp;

	temp.int_data=data;
	out_port(IODATAREG0,temp.byte_data[1]);
	out_port(IODATAREG0,temp.byte_data[0]);
}
//________________________________________
void CC832DX::put_WORD1(short data)
{
	union
	{
		short  int_data;
		BYTE byte_data[2];
	}
	temp;

	temp.int_data=data;
	out_port(IODATAREG1,temp.byte_data[1]);
	out_port(IODATAREG1,temp.byte_data[0]);
}
//________________________________________
//lm628_ready:test BUSY bit, returns FALSE if time out
BOOL CC832DX::lm628_ready0(BYTE channel)
{            
	struct _timeb timebuffer;
  long double t,t1;
	
  _ftime( &timebuffer );
	t=(long double)(timebuffer.time + 0.001*timebuffer.millitm);

	out_port(IOADDRREG0,CONF_PARM | channel);              //command reg. 
	do
	{                 
	  _ftime( &timebuffer );
		t1=(long double)(timebuffer.time + 0.001*timebuffer.millitm);
	}
	while((in_port(IODATAREG0) & 0x1) && t1<=t+0.003);    //test BUSY bit 
	if (t1<=t+0.003) return TRUE; else return FALSE;
}
//________________________________________
BOOL CC832DX::lm628_ready1(BYTE channel)
{            
	struct _timeb timebuffer;
  long double t,t1;
	
  _ftime( &timebuffer );
	t=(long double)(timebuffer.time + 0.001*timebuffer.millitm);
	out_port(IOADDRREG1,CONF_PARM | channel);              //command reg. 
	do
	{                 
	  _ftime( &timebuffer );
		t1=(long double)(timebuffer.time + 0.001*timebuffer.millitm);
	}
	while((in_port(IODATAREG1) & 0x1) && t1<=t+0.003);    //test BUSY bit 
	if (t1<=t+0.003) return TRUE; else return FALSE;
}
//________________________________________
//init:basic initialisation for one C832 channel
void CC832DX::init912_0(BYTE channel,long kp,long ki,long kd,long il,long acc,long vel)
{
	drive628_0(channel,RESET,0,0);
	drive628_0(channel,RSTI,0,0);
	drive628_0(channel,MSKI,0,0);
	drive628_0(channel,LFIL,0x8,kp);
	drive628_0(channel,LFIL,0x4,ki);
	drive628_0(channel,LFIL,0x2,kd);
	drive628_0(channel,LFIL,0x1,il);
	drive628_0(channel,UDF,0,0);
	drive628_0(channel,LTRJ,0x20,acc);
	drive628_0(channel,LTRJ,0x8,vel);
}
//________________________________________
void CC832DX::init912_1(BYTE channel,long kp,long ki,long kd,long il,long acc,long vel)
{
	drive628_1(channel,RESET,0,0);
	drive628_1(channel,RSTI,0,0);
	drive628_1(channel,MSKI,0,0);
	drive628_1(channel,LFIL,0x8,kp);
	drive628_1(channel,LFIL,0x4,ki);
	drive628_1(channel,LFIL,0x2,kd);
	drive628_1(channel,LFIL,0x1,il);
	drive628_1(channel,UDF,0,0);
	drive628_1(channel,LTRJ,0x20,acc);
	drive628_1(channel,LTRJ,0x8,vel);
}
//________________________________________
short CC832DX::parse_arg(short nargs,char *pargv[],char *pident,char *pfmt,void *pvalue)
{
	short i;
	char *pscan = NULL;

	for (i=1; i<nargs; i++)
	{                     /* tester tous les arguments */
		if (strncmp(pargv[i],pident,strlen(pident)))
			continue;                                 /* pident non trouv */
		if (pvalue==NULL)
			return 1;                                 /* pas de conversion de valeur */
		if (strlen(pargv[i]) != strlen(pident))     /* blanc aprs pident ? */
			pscan=&(pargv[i][strlen(pident)]);        /* pas de blancs */
		else
			if (i++<nargs)
				pscan=(char *)pargv[i];                 /* vide */
		if (pscan!=NULL) {                          /* convertir */
			return sscanf(pscan,pfmt,pvalue) ? 1 : 0;
		}
	}
	return 0;
}
//________________________________________
BOOL CC832DX::TEST_BUSY0(char channel)
{
	if (!lm628_ready0(channel))
	{
		return FALSE;
	}
	else
		return TRUE;
}
//________________________________________
BOOL CC832DX::TEST_BUSY1(char channel)
{
	if (!lm628_ready1(channel))
	{
		return FALSE;
	}
	else
		return TRUE;
}
//________________________________________
//fin_course: Test si axe  en fin de course
//						(Renvoie n1 si axe en surcourse, sinon renvoie 0; axe 0 interdit)
char CC832DX::fin_course(char axe)
{
	long IRQ;
	switch (axe)
	{
		case 1://Axe x
			out_port(IOADDRREG0,CONF_PARM | 0x7);//bits[0]+bits[1]+bits[2] --> Read and reset interrupt source (p3)
			IRQ=(long)in_port(IODATAREG0);//Lect. reg. d'interruption
			if (IRQ & 0x1)
				return 1;//Moteur X en surcourse
			else
				return 0;
		break;		
		case 2://Axe y
			out_port(IOADDRREG0,CONF_PARM | 0x7);//bits[0]+bits[1]+bits[2] --> Read and reset interrupt source (p3)
			IRQ=(long)in_port(IODATAREG0);//Lect. reg. d'interruption
			if (IRQ & 0x2)
				return 1;//Moteur Y en surcourse
			else
				return 0;
		break;
		case 3://Axe z
			out_port(IOADDRREG1,CONF_PARM | 0x7);//bits[0]+bits[1]+bits[2] --> Read and reset interrupt source (p3)
			IRQ=(long)in_port(IODATAREG1);//Lect. reg. d'interruption
			if (IRQ & 0x1)
				return 1;//Moteur Z en surcourse
			else
				return 0;
		break;
		case 4://Axe ?
			out_port(IOADDRREG1,CONF_PARM | 0x7);//bits[0]+bits[1]+bits[2] --> Read and reset interrupt source (p3)
			IRQ=(long)in_port(IODATAREG1);//Lect. reg. d'interruption
			if (IRQ & 0x2)
				return 1;//Moteur ? en surcourse
			else
				return 0;
		break;		
		default:
			return 0;
		break;	
	}
}
//________________________________________
BOOL CC832DX::OK(BYTE channel)
{
	BOOL ok;
	if (m_OKConnect==FALSE)
		ok=FALSE;
	else
	if (lm628_ready0(channel))	ok=TRUE; else ok=FALSE;
	return ok;
}
//________________________________________
//AB: Abort (Arrt brutal avec dclration maxi)
void CC832DX::AB(char axe)
{
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,LTRJ,0x200,0);
			drive628_0(0,STT,0,0);
			break;
		case 2://Axe y
			drive628_0(1,LTRJ,0x200,0);
			drive628_0(1,STT,0,0);
			break;
		case 3://Axe z
			drive628_1(0,LTRJ,0x200,0);
			drive628_1(0,STT,0,0);
			break;
		case 4://Axe ?
			drive628_1(1,LTRJ,0x200,0);
			drive628_1(1,STT,0,0);
			break;
		default://Tous les axes
			drive628_0(0,LTRJ,0x200,0);
			drive628_0(0,STT,0,0);
			drive628_0(1,LTRJ,0x200,0);
			drive628_0(1,STT,0,0);
			/*
			drive628_1(0,LTRJ,0x200,0);
			drive628_1(0,STT,0,0);
			drive628_1(1,LTRJ,0x200,0);
			drive628_1(1,STT,0,0);
			*/
	}
}
//________________________________________
//DH: Dfinition Home (Position origine des axes [0, 4])
void CC832DX::DH(char axe)
{
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,DFH,0,0);
			break;
		case 2://Axe y
			drive628_0(1,DFH,0,0);
			break;
		case 3://Axe z
			drive628_1(0,DFH,0,0);
			break;
		case 4://Axe ?
			drive628_1(1,DFH,0,0);
			break;
		default://Tous les axes
			drive628_0(0,DFH,0,0);
			drive628_0(1,DFH,0,0);
			/*
			drive628_1(0,DFH,0,0);
			drive628_1(1,DFH,0,0);
			*/
	}
}
//________________________________________
//GH: Retour  la position origine des axes (Go_Home)
void CC832DX::GH(char axe)
{
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			MA(1,0);
			break;
		case 2://Axe y
			MA(2,0);
			break;
		case 3://Axe z
			MA(3,0);
			break;
		case 4://Axe ?
			MA(4,0);
			break;
		default://Tous les axes
			MA(1,0);
			MA(2,0);
			/*
			MA(3,0);
			MA(4,0);
			*/
	}
}
//________________________________________
//IT: Init axes avec paramtres vitesse, acclration, ... par dfaut
void CC832DX::IT(char axe)
{
	//Paramtres par dfaut
	long
		kp= 1000,      //Valeurs par dfaut
		ki= 100,
		kd= 1000,
		il= 1000,
		acc=500,       //10 U/s*s at 256 s
		vel=(long)(m_fVit*m_lCte);
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			init912_0(0,kp,ki,kd,il,acc,vel);
			break;
		case 2://Axe y
			init912_0(1,kp,ki,kd,il,acc,vel);
			break;
		case 3://Axe z
			init912_1(0,kp,ki,kd,il,acc,vel);
			break;
		case 4://Axe ?
			init912_1(1,kp,ki,kd,il,acc,vel);
			break;
		default://Tous les axes
			init912_0(0,kp,ki,kd,il,acc,vel);
			init912_0(1,kp,ki,kd,il,acc,vel);
			/*
			init912_1(0,kp,ki,kd,il,acc,vel);
			init912_1(1,kp,ki,kd,il,acc,vel);
			*/
	}
}
//________________________________________
//MA: Dplacement absolu des axes
void CC832DX::MA(char axe,float x)
{
	long l=(long)(x*m_lCte);
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,LTRJ,0x2,l);
			drive628_0(0,STT,0,0);
		break;
		case 2://Axe y
			drive628_0(1,LTRJ,0x2,l);
			drive628_0(1,STT,0,0);
		break;
		case 3://Axe z
			drive628_1(0,LTRJ,0x2,l);
			drive628_1(0,STT,0,0);
			break;
		case 4://Axe ?
			drive628_1(1,LTRJ,0x2,l);
			drive628_1(1,STT,0,0);
			break;
		default://Tous les axes
			drive628_0(0,LTRJ,0x2,l);
			drive628_0(0,STT,0,0);
			drive628_0(1,LTRJ,0x2,l);
			drive628_0(1,STT,0,0);
			/*
			drive628_1(0,LTRJ,0x2,l);
			drive628_1(0,STT,0,0);
			drive628_1(1,LTRJ,0x2,l);
			drive628_1(1,STT,0,0);
			*/
	}
}
//________________________________________
//MF: Motor Off
void CC832DX::MF(char axe)
{
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,LTRJ,0x100,0);
			drive628_0(0,STT,0,0);
			break;
		case 2://Axe y
			drive628_0(1,LTRJ,0x100,0);
			drive628_0(1,STT,0,0);
			break;
		case 3://Axe z
			drive628_1(0,LTRJ,0x100,0);
			drive628_1(0,STT,0,0);
			break;
		case 4://Axe ?
			drive628_1(1,LTRJ,0x100,0);
			drive628_1(1,STT,0,0);
			break;
		default://Tous les axes
			drive628_0(0,LTRJ,0x100,0);
			drive628_0(0,STT,0,0);
			drive628_0(1,LTRJ,0x100,0);
			drive628_0(1,STT,0,0);
			/*
			drive628_1(0,LTRJ,0x100,0);
			drive628_1(0,STT,0,0);
			drive628_1(1,LTRJ,0x100,0);
			drive628_1(1,STT,0,0);
			*/
	}
}
//________________________________________
//MN: Motor On
void CC832DX::MN(char axe)
{
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,LTRJ,0x2+0x1,0);
			drive628_0(0,STT,0,0);
			break;
		case 2://Axe y
			drive628_0(1,LTRJ,0x2+0x1,0);
			drive628_0(1,STT,0,0);
			break;
		case 3://Axe z
			drive628_1(0,LTRJ,0x2+0x1,0);
			drive628_1(0,STT,0,0);
			break;
		case 4://Axe ?
			drive628_1(1,LTRJ,0x2+0x1,0);
			drive628_1(1,STT,0,0);
			break;
		default://Tous les axes
			drive628_0(0,LTRJ,0x2+0x1,0);
			drive628_0(0,STT,0,0);
			drive628_0(1,LTRJ,0x2+0x1,0);
			drive628_0(1,STT,0,0);
			/*
			drive628_1(0,LTRJ,0x2+0x1,0);
			drive628_1(0,STT,0,0);
			drive628_1(1,LTRJ,0x2+0x1,0);
			drive628_1(1,STT,0,0);
			*/
	}
}
//________________________________________
//MR: Dplacement relatif des axes
void CC832DX::MR(char axe,float x)
{
	long l=(long)(x*m_lCte);
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,LTRJ,0x2+0x1,l);
			drive628_0(0,STT,0,0);
			break;
		case 2://Axe y
			drive628_0(1,LTRJ,0x2+0x1,l);
			drive628_0(1,STT,0,0);
			break;
		case 3://Axe z
			drive628_1(0,LTRJ,0x2+0x1,l);
			drive628_1(0,STT,0,0);
			break;
		case 4://Axe ?
			drive628_1(1,LTRJ,0x2+0x1,l);
			drive628_1(1,STT,0,0);
			break;
		default://Tous les axes
			drive628_0(0,LTRJ,0x2+0x1,l);
			drive628_0(0,STT,0,0);
			drive628_0(1,LTRJ,0x2+0x1,l);
			drive628_0(1,STT,0,0);
			/*
			drive628_1(0,LTRJ,0x2+0x1,l);
			drive628_1(0,STT,0,0);
			drive628_1(1,LTRJ,0x2+0x1,l);
			drive628_1(1,STT,0,0);
			*/
	}
}
//________________________________________
//MT: Moteur on Target (Test si moteur arriv)
char CC832DX::MD(char axe)
{
	if (m_OKCarte)
	{
		switch (axe)
		{
			case 1://Axe x
				if (!(drive628_0(0,RDSIGS,0,0)&0x400)) return 0; else return 1;
			case 2://Axe y
				if (!(drive628_0(1,RDSIGS,0,0)&0x400)) return 0; else return 1;
			case 3://Axe z
				if (!(drive628_1(0,RDSIGS,0,0)&0x400)) return 0; else return 1;
			case 4://Axe ?
				if (!(drive628_1(1,RDSIGS,0,0)&0x400)) return 0; else return 1;
			default://Tous les axes
				if ((!(drive628_0(0,RDSIGS,0,0)&0x400))||(!(drive628_0(1,RDSIGS,0,0)&0x400))||(!(drive628_1(0,RDSIGS,0,0)&0x400))/*||(!(drive628_1(1,RDSIGS,0,0)&0x400))*/)
					return 0; else return 1;
		}
	}
	else
	{
		return 0;
	}
}
//________________________________________
//RT: Reset axes
void CC832DX::RT(char axe)
{
	if (m_OKConnect)
	{
		switch (axe)
		{
			case 1://Axe x
				drive628_0(0,RESET,0,0);
			break;
			case 2://Axe y
				drive628_0(1,RESET,0,0);
			break;
			case 3://Axe z
				drive628_1(0,RESET,0,0);
			break;
			case 4://Axe ?
				drive628_1(1,RESET,0,0);
			break;
			default://Tous les axes
				drive628_0(0,RESET,0,0);
				drive628_0(1,RESET,0,0);
				/*
				drive628_1(0,RESET,0,0);
				drive628_1(1,RESET,0,0);
				*/
			break;
		}
	}
}
//________________________________________
//SA: Set_Acceleration (Dfinition acclration)
void CC832DX::SA(char axe,float a)
{
	long l=(long)(a*m_lCte);
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,LTRJ,0x20,l);
			break;
		case 2://Axe y
			drive628_0(1,LTRJ,0x20,l);
			break;
		case 3://Axe z
			drive628_1(0,LTRJ,0x20,l);
			break;
		case 4://Axe ?
			drive628_1(1,LTRJ,0x20,l);
			break;
		default://Tous les axes
			drive628_0(0,LTRJ,0x20,l);
			drive628_0(1,LTRJ,0x20,l);
			/*
			drive628_1(0,LTRJ,0x20,l);
			drive628_1(1,LTRJ,0x20,l);
			*/
	}
}
//________________________________________
//ST: Stop (Arrt dclration programme)
void CC832DX::ST(char axe)
{
	if (m_OKCarte)
	{
		switch (axe)
		{
			case 1://Axe x
				drive628_0(0,LTRJ,0x400,0);
				drive628_0(0,STT,0,0);
			break;
			case 2://Axe y
				drive628_0(1,LTRJ,0x400,0);
				drive628_0(1,STT,0,0);
			break;
			case 3://Axe z
				drive628_1(0,LTRJ,0x400,0);
				drive628_1(0,STT,0,0);
			break;
			case 4://Axe ?
				drive628_1(1,LTRJ,0x400,0);
				drive628_1(1,STT,0,0);
			break;
			default://Tous les axes
				drive628_0(0,LTRJ,0x400,0);
				drive628_0(0,STT,0,0);
				drive628_0(1,LTRJ,0x400,0);
				drive628_0(1,STT,0,0);
				/*
				drive628_1(0,LTRJ,0x400,0);
				drive628_1(0,STT,0,0);
				drive628_1(1,LTRJ,0x400,0);
				drive628_1(1,STT,0,0);
				*/
			break;
		}
	}
}
//________________________________________
//SV: Set_Velocity (Dfinition vitesse)
void CC832DX::SV(char axe,float v)
{
	long l=(long)((v/3.6)*m_lCte);
	m_fVit=v;
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,LTRJ,0x8,l);
		break;
		case 2://Axe y
			drive628_0(1,LTRJ,0x8,l);
		break;
		case 3://Axe z
			drive628_1(0,LTRJ,0x8,l);
		break;
		case 4://Axe ?
			drive628_1(1,LTRJ,0x8,l);
		break;
		default://Tous les axes
			drive628_0(0,LTRJ,0x8,l);
			drive628_0(1,LTRJ,0x8,l);
			/*
			drive628_1(0,LTRJ,0x8,l);
			drive628_1(1,LTRJ,0x8,l);
			*/
		break;	
	}
}
//________________________________________
//TB: Test_Busy
char CC832DX::TB(char axe)
{
	if (m_OKCarte)
	{
		switch (axe)
		{
			case 1://Axe x
				if (!lm628_ready0(0))	return 0; else return 1;
			case 2://Axe y
				if (!lm628_ready0(1))	return 0; else return 1;
			case 3://Axe z
				if (!lm628_ready1(0))	return 0; else return 1;
			case 4://Axe ?
				if (!lm628_ready1(1))	return 0; else return 1;
			default://Tous les axes
				if ((!lm628_ready0(0))||(!lm628_ready0(1))||(!lm628_ready1(0))/*||(!lm628_ready1(1))*/)
					return 0; else return 1;
		}
	}
	else
		return 1;
}
//________________________________________
//TP: Demande de la position courante d'un axe (0 non permis)
float CC832DX::TP(char axe)
{
	float l=1e10;
	if (m_OKCarte)
	switch (axe)
	{
		case 1://Axe x
			l=drive628_0(0,RDRP,0,0);
		break;
		case 2://Axe y
			l=drive628_0(1,RDRP,0,0);
		break;
		case 3://Axe z
			l=drive628_1(0,RDRP,0,0);
		break;
		case 4://Axe ?
			l=drive628_1(1,RDRP,0,0);
		break;
		default:
			l=1e10;
		break;
	}

	if (l==1e10)
	{
		return 1e10;
	}
	else
		return (float)(1.0*l/m_lCte);
}                         
//________________________________________
//RI: Reset interruptions 
void CC832DX::RI(char axe)
{
	if (m_OKConnect)
	switch (axe)
	{
		case 1://Axe x
			drive628_0(0,RSTI,0,0);
			drive628_0(0,MSKI,0,0);
		break;	
		case 2://Axe y
			drive628_0(1,RSTI,0,0);
			drive628_0(1,MSKI,0,0);
		break;	
		case 3://Axe z
			drive628_1(0,RSTI,0,0);
			drive628_1(0,MSKI,0,0);
		break;	
		case 4://Axe ?
			drive628_1(1,RSTI,0,0);
			drive628_1(1,MSKI,0,0);
		break;	
		case 0://Tous les axes
			drive628_0(0,RSTI,0,0);
			drive628_0(0,MSKI,0,0);
			drive628_0(1,RSTI,0,0);
			drive628_0(1,MSKI,0,0);
			/*
			drive628_1(0,RSTI,0,0);
			drive628_1(0,MSKI,0,0);
			drive628_1(1,RSTI,0,0);
			drive628_1(1,MSKI,0,0);
			*/
		break;	
	}
} 
//________________________________________
//WS: Wait_Stop - Attente fin de mvt axe et contrle des capteurs fin de course
void CC832DX::WS(char axe)
{
	if (m_OKCarte)
	while ((!MD(axe)) && !BT(axe))
	{
		;
	}
}
//________________________________________
//BT: Test bute de fin de course et renvoi axe en surcourse: 1:X, 2:Y,..., 0:Aucun)
char CC832DX::BT(char axe)
{
	char c=0;
	if (m_OKCarte)
	{
		switch (axe)
		{
			case 1://Axe x
				//fin_course(axe):renvoie 1 si axe en bute...
				if (fin_course(1)) 
				{
					AB(1);//Arrt brutal axe 1
					MF(1);
					c=1;
				}
			break;	
			case 2://Axe y
				if (fin_course(2)) 
				{
					AB(2);//Arrt brutal axe 2
					MF(2);
					c=2;
				}
			break;	                        
			/*
			case 3://Axe z
				if (fin_course(3)) 
				{
					AB(3);//Arrt brutal axe 3
					MF(3);
					c=3;
				}
			break;	
			case 4://Axe ?
				if (fin_course(4)) 
				{
					AB(4);//Arrt brutal axe 4
					MF(4);
					c=4;
				}
			break;
			*/	
			case 0://Tous les axes
				if (fin_course(1)) 
				{
					AB(1);//Arrt brutal axe 1
					MF(1);
					c=1;
				}
				else	
				if (fin_course(2)) 
				{
					AB(2);//Arrt brutal axe 2
					MF(2);
					c=2;
				}
				else
				/*	
				if (fin_course(3)) 
				{
					AB(3);//Arrt brutal axe 3
					MF(3);
					c=3;
				}
				else	
				if (fin_course(4)) 
				{
					AB(4);//Arrt brutal axe 4
					MF(4);
					c=4;
				}
				*/	
			break;	
		}//switch
	}
	else
		c=0;
	return c;
}
